//
//  FriendsProtocols.swift
//  VK Tosters
//
//  Created programmist_np on 21/01/2020.
//  Copyright © 2020 programmist_np. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import Foundation
import SwiftyJSON
import RealmSwift

//MARK: Wireframe -
protocol FriendsWireframeProtocol: class {
    func openProfile(userId: Int)
    func openChat(from conversation: Conversation)
}
//MARK: Presenter -
protocol FriendsPresenterProtocol: class {
    func start(request: FriendModel.Request.RequestType)
    func presentData(response: FriendModel.Response.ResponseType)
    func onEvent(message: String, _ style: MessageViewState)
    func onError(message: String, _ style: MessageViewState)
    func onTapFriend(userId: Int)
    func onTapToChat(peerId: Int)
    func onErrorConnection()
}

//MARK: Interactor -
protocol FriendsInteractorProtocol: class {
    var presenter: FriendsPresenterProtocol?  { get set }
    func start(request: FriendModel.Request.RequestType)
    func makeRequest(request: FriendModel.Request.RequestType)
}

//MARK: View -
protocol FriendsViewProtocol: class {
    var presenter: FriendsPresenterProtocol?  { get set }
    func displayData(viewModel: FriendModel.ViewModel.ViewModelData)
    func showStatusError(message: String, error: ErrorLocalize?, _ style: MessageViewState, with isLoading: Bool)
    func showErrorConnection()
}
